Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | File List | Namespace Members | Class Members | File Members | Related Pages

# SUSANEdgeDetectionLite Class Reference

This class represents a non-linear image edge detection filter. More...

`#include <SUSANEdgeDetectionLite.h>`

List of all members.

## Public Types
enum | ColorSpectra { componentA = 0, componentB, componentC }
enum | { GEOMETRIC_THRESHOLD = 255*8*3/4 }
## Public Member Functions
| SUSANEdgeDetectionLite (int edgeThreshold)
| Constructor.
| ~SUSANEdgeDetectionLite ()
| Destructor.
bool | isEdgePoint (const Image &image, int X, int Y, ColorSpectra channel) const
| Checks if a given point is an edge point.
## Private Member Functions
void | setupSusanLUT (int threshold)
| Initializes the LookUpTable.
unsigned char | correlation (int delta) const
| The correlation function, precomputed.
## Private Attributes
unsigned char | Susan_LUT [255]
| A LookUpTable containing a correlation function.

## Detailed Description

This class represents a non-linear image edge detection filter.

Unlike traditional edge detectors gradient based like Sobel or LoG, this filter doesnt perform a derivative operation on the image, (which is an hi-pass characteristic) thus has a better noise-rejection performance. This implementation is dubbed "Lite" as the heaviest passes of the full algorithm (edge direction calculation, non-maxima suppression, binary thinning) have been stripped out for performance reasons.

Author:
  Walter Nistico

Definition at line 26 of file SUSANEdgeDetectionLite.h.

## Member Enumeration Documentation

enum SUSANEdgeDetectionLite::ColorSpectra

  | Enumeration values:
  componentA |
  componentB |
  componentC |
Definition at line 31 of file SUSANEdgeDetectionLite.h.

anonymous enum

  | Enumeration values:
  GEOMETRIC_THRESHOLD |
Definition at line 32 of file SUSANEdgeDetectionLite.h.

## Constructor & Destructor Documentation

SUSANEdgeDetectionLite::SUSANEdgeDetectionLite | ( | int | edgeThreshold | ) |

| Constructor. Definition at line 11 of file SUSANEdgeDetectionLite.cpp. References setupSusanLUT().

Here is the call graph for this function:

SUSANEdgeDetectionLite::~SUSANEdgeDetectionLite | ( |  | ) |

| Destructor. Definition at line 16 of file SUSANEdgeDetectionLite.cpp.

## Member Function Documentation

bool SUSANEdgeDetectionLite::isEdgePoint | ( | const Image & | image,
|  | int | X,
|  | int | Y,
|  | ColorSpectra | channel
| ) | const

  | Checks if a given point is an edge point. Parameters:
  image | The source image
  X | The X coordinate of the given point
  Y | The Y coordinate of the given point
  channel | The chosen color spectrum (Y, U, or V for ex.)
Returns: is the point an edge point? Definition at line 30 of file SUSANEdgeDetectionLite.cpp. References correlation(), GEOMETRIC_THRESHOLD, and Image::image. Referenced by VLCBeaconDetector::scanForBeaconPart(), SlamBeaconDetector::scanForBeaconPart(), GT2005BeaconDetector::scanForBeaconPart(), MSH2004EdgeDetection::susanVote(), and GT2004EdgeDetection::susanVote().

Here is the call graph for this function:

void SUSANEdgeDetectionLite::setupSusanLUT | ( | int | threshold | ) | `[private]`

| Initializes the LookUpTable. Definition at line 19 of file SUSANEdgeDetectionLite.cpp. Referenced by SUSANEdgeDetectionLite().

unsigned char SUSANEdgeDetectionLite::correlation | ( | int | delta | ) | const`[inline, private]`

| The correlation function, precomputed. Definition at line 65 of file SUSANEdgeDetectionLite.h. Referenced by isEdgePoint().

## Member Data Documentation

unsigned char SUSANEdgeDetectionLite::Susan_LUT[255]`[private]`

| A LookUpTable containing a correlation function. Definition at line 55 of file SUSANEdgeDetectionLite.h.

The documentation for this class was generated from the following files:

- Modules/ImageProcessor/ImageProcessorTools/SUSANEdgeDetectionLite.h
- Modules/ImageProcessor/ImageProcessorTools/SUSANEdgeDetectionLite.cpp